﻿using System.Collections;
using System;
using UnityEngine;

namespace Mod
{    
    public struct RepositionSwitch
    {
        public static bool Condition;
    }
    public class Mod : MonoBehaviour
    {
        public static void Main()
        {
            RepositionSwitch.Condition=true;
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Automatic limb repositioning Switch",
                    DescriptionOverride = "Switch the Automatic limb repositioning",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/Icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        RepositionSwitch.Condition=!RepositionSwitch.Condition;
                        if(RepositionSwitch.Condition){
                            ModAPI.Notify("Automatic limb repositioning is now on");
                        }
                        else{
                            ModAPI.Notify("Automatic limb repositioning is now off");
                        }
                        Destroy(Instance);
                    }
                }
            );            
            ModAPI.OnItemSpawned += (sender, args) => {
                if(RepositionSwitch.Condition){
                    if(args.Instance.HasComponent<PersonBehaviour>()){
                        foreach(LimbBehaviour limb in args.Instance.GetComponent<PersonBehaviour>().Limbs){
                            limb.gameObject.GetOrAddComponent<AutoLimbReposition>();
                        }
                    }
                }
            };

        }
    }
    public class AutoLimbReposition : MonoBehaviour
    {
        LimbBehaviour limb;
        Vector2 AnchorPosition;

        private void Awake() {
            limb=this.GetComponent<LimbBehaviour>();
            AnchorPosition=limb.Joint.connectedAnchor;
        }
        private void Update() {
            if(limb.Joint.connectedAnchor!=AnchorPosition){
                Vector2 Displacement=limb.Joint.connectedBody.gameObject.transform.TransformPoint(AnchorPosition)-limb.Joint.connectedBody.gameObject.transform.TransformPoint(limb.Joint.connectedAnchor);
                this.transform.position=(Vector2)this.transform.position+Displacement;
            }
        }
    }
}